/* sample program that has been written in order to generate minefield and fill the grids in the field with the proper values.
The mines have been assigned randomly with the help of the rand() function. */


#include <iostream>
#include <stdlib.h>
#include <ctime>
using namespace std;
#define MAXSIZE 25
int mines;
int row;
int col;
int field[MAXSIZE][MAXSIZE];


void getvalue() // accepts the value inputted from the user
{
cout<<"Enter the value of Row b/w 2 and 25 :-"<<endl;
cin>>row;
cout<<"Enter the value of column b/w 2 and 25 :-"<<endl;
cin>>col;
cout<<"Enter the value of No. of mines between 1 and "<<row*col/2<<"!!"<<endl;
cin>>mines;
}
bool checkmines() // this function checks whether the value of mines inputted is proper or not
{
    bool flag=false;
    if(mines<0 || mines >(row*col/2))
        flag=true;
    if(row<0 || col<0)
        flag=true;
    return flag;
}
bool checkindex() // this function checks whether the value of row and column size inputted is proper or not
{
    bool flag=false;
    if(row<1 || row>25)
        flag=true;
    if(col<0 || col>25)
        flag=true;
    return flag;
}
void minesgenerator() // generates the minefield using rand() function
{
	int i,j,r,c; // the logic used is that if mines are assigned a value of 9 in the 2D array
	for(i=0;i<mines;i++)
	{
		r=rand()%row;
		c=rand()%col;
		if(field[r][c]==9)
		{
            		i--;
            		continue;
        	}
        	else
            		field[r][c]=9;
    }
}
void display() // displays the row x column array
{
    int i,j;
    for(i=0;i<row;i++)
        {
        for(j=0;j<col;j++)
            cout<<field[i][j]<<"\t";
        cout<<endl;
        cout<<endl;
        }
}
void valuegenerator() // checks each and every array element for mines.If mines are found then the values of the 8 surrounding boxes are increased by 1
{
    int i,j;
    for(i=0;i<row;i++)
        {
            for(j=0;j<col;j++)
            {
                if(field[i][j]==9)
                   {
                       if((i-1)>=0 && (j-1)>=0)
                       {
                           if(field[i-1][j-1]!=9)
                           field[i-1][j-1]++;
                       }
                       if((i-1)>=0)
                       {
                           if(field[i-1][j]!=9)
                           field[i-1][j]++;
                       }
                       if((i-1)>=0 && (j+1)<col)
                       {
                           if(field[i-1][j+1]!=9)
                           field[i-1][j+1]++;
                       }
                       if((j-1)>=0)
                       {
                           if(field[i][j-1]!=9)
                           field[i][j-1]++;
                       }
                       if((j+1)<col)
                       {
                           if(field[i][j+1]!=9)
                           field[i][j+1]++;
                       }
                       if((i+1)<row && (j-1)>=0)
                       {
                           if(field[i+1][j-1]!=9)
                           field[i+1][j-1]++;
                       }
                       if((i+1)<row)
                       {
                           if(field[i+1][j]!=9)
                           field[i+1][j]++;
                       }
                       if((i+1)<row && (j+1)<col)
                       {
                           if(field[i+1][j+1]!=9)
                           field[i+1][j+1]++;
                       }
                   }
            }
        }

}
int main()
{

    getvalue();
    srand(time(0));
    int i,j;
    for(i=0;i<MAXSIZE;i++)
        for(j=0;j<MAXSIZE;j++)
            field[i][j]=0;
    if(checkmines() || checkindex())
    {
        cout<<"Input value invalid"<<endl;
        return 0;
    }
    else
    {
         minesgenerator();
         valuegenerator();
         display();
    }
    return 0;
}
