#include<assert.h>
#include"bitmap.h"
#include <iostream>
#include<time.h>


SimpleWindow GameWindow("Minesweeper",28.4,14.9,Position(0,0));
BitMap GW(GameWindow);
BitMap Background(GameWindow);
BitMap Recruit(GameWindow);
BitMap Regular(GameWindow);
BitMap Veteran(GameWindow);
BitMap Highscore(GameWindow);
BitMap Restart(GameWindow);
BitMap Signout(GameWindow);
BitMap Pirateflag(GameWindow);
BitMap MineImg(GameWindow);
BitMap BackBttn(GameWindow);
BitMap Minenum(GameWindow);
BitMap Newscore(GameWindow);


void displaymine (float x, float y)	// function to display image of mine
{
	GW.Load("smallmine2.xpm");
	GW.SetPosition(Position(x-0.05,y-0.1));
	GW.Draw();

}


void displayflag(float x,float y)	// function to display the image of flag
{
	GW.Load("redflag.xpm");
	GW.SetPosition(Position(x+0.1,y+0.1));
	GW.Draw();
}


void displaywin()		//function to display the winning screen
{
	GW.Load("win2.xpm");
	GW.SetPosition(Position(0,0));
	GW.Draw();
	Restart.Load("restart.XPM");
	Restart.SetPosition(Position(6,6));
	Restart.Draw();
	Signout.Load("quit.XPM");
	Signout.SetPosition(Position(6.65,7.5));
	Signout.Draw();
}

void displayyoulose()		//function to display the losing screen
{
	GameWindow.RenderRectangle(Position(0,0),Position(29,15),Black,true);
	GW.Load("lose.xpm");
	GW.SetPosition(Position(2,0));
	GW.Draw();
	Restart.Load("restart.XPM");
	Restart.SetPosition(Position(13,3));
	Restart.Draw();
	Signout.Load("quit.XPM");
	Signout.SetPosition(Position(13.65,4.5));
	Signout.Draw();
}
